/******************************************************************************
 * $ java-algs4 WordLadderPlain DATA/5+6_letter_words/words5.txt
 * Time to produce word graph: 0.118
 * Words?  green brown
 * length = 6
 * 0: green
 * 1: greet
 * 2: great
 * 3: groat
 * 4: groan
 * 5: grown
 * 6: brown
 * 
 * Words?  Ctrl-D
 * $  
 ******************************************************************************/

import edu.princeton.cs.algs4.In;
import edu.princeton.cs.algs4.StdIn;
import edu.princeton.cs.algs4.StdOut;
import edu.princeton.cs.algs4.Stopwatch;
import edu.princeton.cs.algs4.BreadthFirstPaths;

public class WordLadderPlain {

    public static void main(String[] args) {
        In in = new In(args[0]);
	Stopwatch sw = new Stopwatch();
	WordGraphPlain wg = new WordGraphPlain(in);
	System.err.println("Time to produce word graph: " + sw.elapsedTime());

	StdOut.print("Words?  ");
        while (!StdIn.isEmpty()) {
            String s = StdIn.readString();
	    String t = StdIn.readString();
            if (!wg.contains(s)) throw new RuntimeException(s + " is not in word list");
            if (!wg.contains(t)) throw new RuntimeException(t + " is not in word list");

	    BreadthFirstPaths bfs = new BreadthFirstPaths(wg.graph(), wg.indexOf(s));
            if (bfs.hasPathTo(wg.indexOf(t))) {
                StdOut.println("length = " + bfs.distTo(wg.indexOf(t)));
		int i = 0;
                for (int v : bfs.pathTo(wg.indexOf(t))) 
                    StdOut.println(i++ + ": " + wg.nameOf(v));
            }
            else StdOut.println("NOT CONNECTED");
	    StdOut.print("\nWords?  ");
        }
    }
}
